/////////////////////////////////////////////////////////////////////////////////////
// local
var
 s_app=external.app
,s_fso
,s_scriptDetails
,s_scriptList
,s_searchList
;
/////////////////////////////////////////////////////////////////////////////////////
// common
function removeChildren(elem){
	while(elem.firstChild)elem.removeChild(elem.firstChild);
}
function loadScript(src,doc){
	if(!doc)doc=document;
	var script=doc.createElement("script");
	script.type="text/javascript";
	script.src=src;
	var head=doc.getElementsByTagName("head")[0];
	head.insertBefore(script,head.firstChild);
}
function arrayIndexOf(ar,v){
	for(i=0;i<ar.length;++i){
		if(ar[i]===v){
			return i;
		}
	}
	return -1;
}
function getFSO(){
	if(!s_fso){
		s_fso=s_app.createObject("Scripting.FileSystemObject");
	}
	return s_fso;
}
function readUnicodeTextFile(path){
	return getFSO().OpenTextFile(path,1,false,-1).ReadAll();
}
function writeUnicodeTextFile(path,txt){
	var	f=getFSO().OpenTextFile(path,2,true,-1);
	f.Write(txt);
	f.Close();
}
function loadScriptDetails(){
	if(!s_scriptDetails){
		s_scriptDetails=[undefined,undefined];
		var	scriptDir=getScriptDirPath(),fso=getFSO();
		var	scriptsPath=fso.BuildPath(scriptDir,"scripts.json");
		if(fso.FileExists(scriptsPath)){
			s_scriptDetails[0]=parseJsonFile(scriptsPath);
		}
		scriptsPath=fso.BuildPath(scriptDir,"reserved\\scripts.json");
		if(fso.FileExists(scriptsPath)){
			s_scriptDetails[1]=parseJsonFile(scriptsPath);
		}
	}
	return s_scriptDetails;
}
function getScriptDetail(script){
	var	isReserved=script.indexOf("reserved\\")===0
		,details=loadScriptDetails()[isReserved?1:0]
		,detail;
	if(details){
		var	key=isReserved?script.substr(9):script;
		detail=details[key];
	}
	return detail;
}
function queryScriptAction(script,action){
	var	detail=getScriptDetail(script);
	if(!detail||!detail.action){
		// no scripts detail(etc. sample.js)
		return true;
	}
	return detail.action.indexOf(action)!==-1;
}
function _getScriptDisplayName(script){
	// remove cmd prefix(script:)
	if(script.indexOf(":")!==-1){
		script=script.substr(7);
	}
	var	detail=getScriptDetail(script);
	if(detail){
		if(detail&&detail.txt){
			script=detail.txt+" ("+script+")";
		}
	}
	return g_txtScript+":"+script;
}
function _getSearchDisplayName(search){
	// remove cmd prefix(search:)
	if(search.indexOf(":")!==-1){
		search=search.substr(7);
	}
	// remove extention
	var	iExt=search.lastIndexOf(".");
	if(-1===iExt){
		iExt=search.length;
	}
	return g_txtSearch+":"+search.substring(0,iExt);
}
function getCmdDisplayName(cmd){
	var	cmdText;
	if(-1===cmd.indexOf(":")){
		cmdText=s_app.getCmdText(cmd);
	}else{
		if(-1!==cmd.indexOf("script:")){
			cmdText=_getScriptDisplayName(cmd);
		}else if(-1!==cmd.indexOf("search:")){
			cmdText=_getSearchDisplayName(cmd);
		}
	}
	if(!cmdText)cmdText=cmd;
	return cmdText;
}
function getScriptList(){
	if(!s_scriptList){
		s_scriptList=s_app.scriptList;
	}
	return s_scriptList;
}
function getSearchList(){
	if(!s_searchList){
		s_searchList=s_app.searchList;
	}
	return s_searchList;
}
function parseJson(txt){
	var	obj;
	try{
		obj=eval("("+txt+")");
	}catch(e){}
	return obj;
}
function parseJsonFile(path){
	var	obj;
	try{
		var	txt=readUnicodeTextFile(path);
		obj=parseJson(txt);
	}catch(e){}
	return obj;
}
function pathRemoveFileSpec(path){
	return path.substr(0,path.lastIndexOf('\\'));
}
function getSettingDirPath(){
	return getFSO().BuildPath(pathRemoveFileSpec(s_app.path),"setting");
}
function getScriptDirPath(){
	return getFSO().BuildPath(pathRemoveFileSpec(s_app.path),"script");
}
function addOption(options,val,txt){
	var	item=document.createElement("option");
	options.add(item);
	item.value=val;
	item.innerText=txt;
	return item;
}
function getSelectedValue(options){
	return options[options.selectedIndex].value;
}
function toggleEnable(chk,id){
	var elem=$$(id);
	if(elem){
		elem.disabled=!chk.checked;
	}
}
function valueIsCueBanner(elem){
	return -1!==elem.className.indexOf("cCueBanner");
}
function toggleCueBanner(ev,bannerTxt){
	if("focusin"===ev.type){
		if(valueIsCueBanner(ev.target)){
			ev.target.value="";
			$(ev.target).toggleClass("cCueBanner");
		}
	}else{
		if(0===ev.target.value.length){
			$(ev.target).toggleClass("cCueBanner");
			ev.target.value=bannerTxt;
		}
	}
}
function getCmdFlags(settingName){
	var	cnt=g_cmdFlags.length,flags=0x1;
	for(i=0;i<cnt;++i){
		if(settingName===g_cmdFlags[i][0]){
			flags=g_cmdFlags[i][1];
			break;
		}
	}
	return flags;
}
function getCheckedIdx(v,defVal){
	var	ret_idx=defVal,checkedCnt=v.length;
	for(checked_i=0;checked_i<checkedCnt;++checked_i){
		if(v[checked_i].checked){
			ret_idx=checked_i;
			break;
		}
	}
	return ret_idx;
}
function getAppStyleText(style){
	var	txt;
	switch(style){
	case 1:txt="シングルスレッド";break;
	case 2:txt="マルチスレッド";break;
	case 3:txt="マルチプロセス";break;
	}
	if(!txt)txt="unknown";
	return txt;
}
function getViewStyleText(style){
	var	txt;
	switch(style){
	case 0:txt="旧スタイル";break;
	case 1:txt="Internet Explorerスタイル";break;
	}
	if(!txt)txt="unknown";
	return txt;
}
/////////////////////////////////////////////////////////////////////////////////////
// input filter
function inputNum(k){
	// num
	if((48<=k&&k<=57)||(96<=k&&k<=105)) return true;
	// del, backspace, ins, <-, ->, home, end, tab
	if(8===k||46===k||45===k||37===k||39===k||35===k||36===k||9===k) {
		return true;
	}
	// return
	if(13===k) {
		optionApply();
		return false;
	}
	return false;
}
function inputAlpNum(k){
	// alp, num
	if(32<=k&&k<=125) return true;
	// del, backspace, ins, <-, ->, home, end, tab
	if(8===k||46===k||45===k||37===k||39===k||35===k||36===k||9===k) {
		return true;
	}
	// return
	if(13===k) {
		optionApply();
		return false;
	}
	return false;
}
// true:OK false:NG
function inputUrl(k){
	if(inputAlpNum(k)){
		return true;
	}

	// _ etc..
	if( 189===k||220===k||222===k||192===k||219===k||
		221===k||186===k||191===k||188===k||190===k||
		187===k||226===k){
		return true;
	}
	return false;
}
/////////////////////////////////////////////////////////////////////////////////////
// select command
// fAddFlags
//    0x1:prevent add menu
function initSelectCmd(options, fAddFlags){
	var	cmdCnt=g_supportCmds.length;
	options.length=0;
	for(i=0;i<cmdCnt;++i){
		var	cmd=g_supportCmds[i];
		if(cmd==="menu"){
			if(fAddFlags&0x1){
				continue;
			}
		}
		addOption(options,cmd,s_app.getCmdText(cmd));
	}
	
	// script
	var	scriptList=getScriptList(),scriptCnt=scriptList.count;
	for(i=0;i<scriptCnt;++i){
		var	filename=scriptList.filename(i);
		if(queryScriptAction(filename,SCRIPTACTION_COMMAND)){
			addOption(options,"script:"+filename,_getScriptDisplayName(filename));
		}
	}
	
	// search
	var	searchList=getSearchList(),searchCnt=searchList.count;
	for(i=0;i<searchCnt;++i){
		addOption(options,"search:"+searchList.filename(i),
			_getSearchDisplayName(searchList.filename(i)));
	}
}
function initOptionCmd(options,cmd){
	options.length=1;
	options[0].value=cmd;
	options[0].text=getCmdDisplayName(cmd);
}
function selectOption(options,value){
	var	cnt=options.length;
	for(i=0;i<cnt;++i){
		if(options[i].value==value){
			options[i].selected=true;
			return true;
		}
	}
	// 初期アイテムを選択
	options.selectedIndex=0;
	return false;
}
function selectOptionCmd(options,cmd){
	var	cnt=options.length;
	for(i=0;i<cnt;++i){
		if(options[i].value===cmd){
			options[i].selected=true;
			return true;
		}
	}
	initOptionCmd(options,cmd);
	return false;
}
function sepCmd(cmd){
	var	ret=new Array(2),iFind=cmd.lastIndexOf(":");
	if(-1!==iFind){
		ret[0]=cmd.substring(0,iFind);
		ret[1]=cmd=value.substring(iFind+1);
	}else{
		ret[0]=cmd;
		ret[1]=null;
	}
	return ret;
}
function selectCmds(category,isSetDefault){
	var	cmdInfo=g_cmdInfo[category];
	for (name in cmdInfo){
		var	cmd=(isSetDefault?cmdInfo[name]:g_setting[name]);
		selectOptionCmd(document[name].v.options,cmd);
	}
}
function dispSelectCmd(select){
	var	value=select.value
		,addFlags=getCmdFlags(select.form.name);
	initSelectCmd(select.options,addFlags);
	selectOptionCmd(select.options,value);
}
/////////////////////////////////////////////////////////////////////////////////////
// err dialog
var ERRCODE_BOOKMARK_SETTING=1;
function errDlg(errCode){
	var	msg="unknown error";
	if(ERRCODE_BOOKMARK_SETTING===errCode){
		msg="ブックマークの設定に失敗しました。";
	}
	alert(msg);
}